package dev.peerat.parser.java;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public abstract class JavaElement{
	
	public abstract <E extends JavaElement> E find(Function<JavaElement, Boolean> finder);
	
	public abstract <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list);

	public abstract VisitorBag visit(Visitor<JavaElement> visitor);
}