package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class CastValue extends Value{
	
	private Token type;
	private Value value;
	
	public CastValue(Token type, Value value){
		this.type = type;
		this.value = value;
	}
	
	public Token getType(){
		return this.type;
	}
	
	public Value getValue(){
		return this.value;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		bag.merge(value.visit(visitor));
		return bag;
	}
	
	

}
