package dev.peerat.parser.visitor;

public abstract class Visitor<T>{
	
	public abstract boolean canVisit(Class<?> type); //TODO change "Class<?> type" into "Object element" ?
	
	public abstract boolean canPropagate();
	
	public abstract VisitorBag visit(T element);
	
}
